' PICBASIC PRO floating point test program

	include "fp0c.bas"	' Include file for 14-bit core with RAM at $0c (24-bit)
'	include "fp20.bas"	' Include file for 14-bit core with RAM at $20 (24-bit)
'	include "fp40.bas"	' Include file for 14-bit core with RAM at $40 (24-bit)
'	include "fp0c32.bas"	' Include file for 14-bit core with RAM at $0c (32-bit)
'	include "fp2032.bas"	' Include file for 14-bit core with RAM at $20 (32-bit)
'	include "fp4032.bas"	' Include file for 14-bit core with RAM at $40 (32-bit)
'	include "fp17.bas"	' Include file for 17Cxxx (24-bit)
'	include "fp1732.bas"	' Include file for 17Cxxx (32-bit)
'	include "fp18.bas"	' Include file for 18Xxxx (24-bit)
'	include "fp1832.bas"	' Include file for 18Xxxx (32-bit)
'	include "fp1832l.bas"	' Long include file for 18Xxxx (32-bit)

' Define the target device for PM assembler
Define	__16F84	1	' Only use for PM, MPASM will define this by itself


	Pause 500	' Wait for LCD to start


' Demonstrate floating point multiply
        aint = 10
        Gosub itofa     ' Convert int to float

        bint = 20
        Gosub itofb     ' Convert int to float

        Gosub fpmul     ' FP multiply (10 * 20)

        Gosub ftoia     ' Convert float to int

        Lcdout $fe, 1, "* ", dec aint
        Pause 1000


' Demonstrate floating point divide
        Gosub itofa     ' Convert int back to float (200)

        bint = 3
        Gosub itofb     ' Convert int to float

        Gosub fpdiv     ' FP divide (200 / 3)

        Gosub ftoia     ' Convert float to int

        Lcdout $fe, 1, "/ ", dec aint


' Demonstrate floating point remainder
        aint = 200
        Gosub itofa     ' Convert int to float

        bint = 3
        Gosub itofb     ' Convert int to float

        Gosub fpdiv     ' FP divide (200 / 3)

        bint = 100
        Gosub itofb     ' Convert int to float

        Gosub fpmul     ' Multiply by 100 to move remainder up 2 places

        Gosub ftoia     ' Convert float to int

        aint = aint // 100      ' Get to the remainder
        Lcdout ".", dec2 aint

        End
